/*
 *  HandoverReplanner.hpp
 *  libmove3D-planners 
 *
 *  Created by Benjamin Vadant on 01/02/13.
 *  Based on Jim Mainprice replanningAlgorithms.hpp/cpp
 *  Copyright 2013 LAAS/CNRS. All rights reserved.
 *
 */

#ifndef HANDOVER_REPLANNER_HPP
#define HANDOVER_REPLANNER_HPP

#include "planner/Replanning/SimpleReplanner.hpp"
#include "API/Trajectory/trajectory.hpp"
#include "API/ConfigSpace/configuration.hpp"
#include "API/Roadmap/graph.hpp"

#include "HRI_costspace/HRICS_Navigation.hpp"

#include "utils/ConfGenerator.h"

#include "P3d-pkg.h"
#include "LightPlanner-pkg.h"

#include <string>

class HandoverReplanner : public SimpleReplanner
{   
public:
    HandoverReplanner(Robot* r);
    ~HandoverReplanner();
    
    bool init();
    void run();
    
private:
    std::pair<bool,confPtr_t> newGoalFromIK();
    std::pair<bool,confPtr_t> newGoalFromList();

    bool goalFromList;
    ConfGenerator* handoverGenerator;
};

#endif
